; Mic, 2008/2013

.686p
.model flat,stdcall
option casemap:none


include \masm32\include\windows.inc
include \masm32\include\kernel32.inc
include \masm32\include\user32.inc
include \masm32\include\gdi32.inc
include \masm32\include\opengl32.inc

includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\user32.lib
includelib \masm32\lib\gdi32.lib
includelib \masm32\lib\opengl32.lib

GL_FRAGMENT_SHADER 	equ 8B30h

DEBUG_SHADER		equ 0
WINDOWED		equ 0

IF WINDOWED EQ 1
SWIDTH			equ 800
SHEIGHT			equ 600
ELSE
SWIDTH			equ 1024
SHEIGHT			equ 768
ENDIF

LARGE_INT STRUCT
	UNION
		STRUCT
			LowPart dd ?
			HighPart dd ?
		ENDS
		QuadPart dq ?
	ENDS
LARGE_INT ENDS

.data

szEdit db 'edit',0

IF WINDOWED EQ 1
szTitle db 'Vienetta',0
ENDIF

szFragShader label byte
db 'uniform float a,b,c;'
db 'const float g=0.0245436926;'
db 'uint m;'
db 'void main() {'
db 'float d,e,f,h,i;'
db 'e=400.0*(gl_FragCoord.x/b);'
db 'f=320.0*(gl_FragCoord.y/c);'
db 'float p=sqrt(((200.0-e)*(200.0-e))+((160.0-f)*(160.0-f)));'
db 'float q=f/p;' 
db 'e=(p*cos(q*p/47.0+a/200.0))+a/2.0;f=(p*sin(q+a/60.0))+a/2.0;'
db 'd=sin((e-1.0)*g)*150.0+sin((e-1)*g*2.0)*150.0;'
db 'd+=p;'
db 'h=((f+d+d)-a/2.0)*g;'
db 'i=cos(h+p/1.4)*(f+e-a)+cos(q*g*2.0)*(p+h/3.0);' 
db 'h=cos(f*g)*144.0-cos(e*g)*212.0*gl_FragCoord.x/b;'
db 'h=(h/2.0+(f-e)*q+p+i/6.2)/100;'
db 'i+=sin(h*2.5)*194.0*sin(q-(p*3.5)*g);'
db 'i+=tan(p*g+h)*134.0*cos(p*g+h);'
db 'm=uint(floor(i/5.75));m=uint(mod(float(m),256.0));i=float(m);'
db 'if (i>=128.0) i=256.0-i;'
db 'float r=p/188.0;'
db 'int xlsb = int(floor(mod((gl_FragCoord.x+a*8.0)/1.5,2.0)));' 
db 'int ylsb = int(floor(mod((gl_FragCoord.y+a*7.0)/1.8,2.0)));'
db 'd=1.2;'
db 'if ((xlsb+ylsb)!=1)d=0.9;'
db 'vec4 s;'
db 'if (i<4.0) s=vec4(0.0,0.0,0.0,1.0);' 
db 'else if (i<100) {h=(gl_FragCoord.x/b);s=vec4(i/64.0+r/8.0,i/256.0,i/112.0,1.0)*(1.0-r)+vec4(i/112.0,i/64.0,i/64.0+r/16.0,1.0)*r*(1-h)+vec4(i/128.0+r/14.0,i/64.0,i/112.0,1.0)*r*h;}'
db 'else s=vec4(1.0,1.0,1.0,1.0);'
db 'gl_FragColor = s*d;}',0

szShaderCode dd offset szFragShader,0

szCreateProgram	db 'glCreateProgram',0
szCreateShader 	db 'glCreateShader',0
szDeleteProgram	db 'glDeleteProgram',0
szDeleteShader 	db 'glDeleteShader',0
szShaderSource	db 'glShaderSource',0
szCompileShader db 'glCompileShader',0
szAttachShader 	db 'glAttachShader',0
szLinkProgram 	db 'glLinkProgram',0
szUseProgram 	db 'glUseProgram',0
szGetUniformLoc db 'glGetUniformLocation',0
szUniform1f 	db 'glUniform1f',0
IF DEBUG_SHADER EQ 1
szGetInfoLog	db 'glGetShaderInfoLog',0
ENDIF
szA		db 'a',0
szB		db 'b',0
szC		db 'c',0
deltaMul	dw 30		; This variable control movement speed

quadCoords	REAL4 -1.0,-1.0, 1.0,-1.0, 1.0,1.0, -1.0,1.0
	
	
.data?

pfd PIXELFORMATDESCRIPTOR <>
dmScreenSettings DEVMODE <>
msg		MSG <>
perfCnt1	LARGE_INT <>
perfCnt2	LARGE_INT <>
perfFreq	LARGE_INT <>
hdc 		HDC ?
hwnd		HWND ?
rect		RECT <>
program 	dd ?
shader 		dd ?
glGetUniformLocation dd ?
glUniform1f 	dd ?
delta1 		dd ?
delta2 		dd ?
delta3 		dd ?
unfD1		dd ?
unfD2		dd ?
unfD3		dd ?

IF DEBUG_SHADER EQ 1
stdout 		dd ?
dummy 		dd ?
szBuffer 	db 512 dup (?)
ENDIF


.code


WinMainCRTStartup:

mov edi,offset pfd
mov ecx,sizeof PIXELFORMATDESCRIPTOR
xor eax,eax
rep stosb
mov pfd.nVersion,1
mov pfd.dwFlags,PFD_SUPPORT_OPENGL OR PFD_DOUBLEBUFFER OR PFD_DRAW_TO_WINDOW
mov pfd.cColorBits,32
mov pfd.cDepthBits,32
mov pfd.dwLayerMask,PFD_MAIN_PLANE
mov pfd.iPixelType,PFD_TYPE_RGBA
 
mov edi,offset dmScreenSettings
mov ecx,sizeof DEVMODE
xor eax,eax
rep stosb
mov dmScreenSettings.dmSize, sizeof DEVMODE
mov dmScreenSettings.dmFields,DM_PELSWIDTH OR DM_PELSHEIGHT
mov dmScreenSettings.dmPelsWidth,SWIDTH
mov dmScreenSettings.dmPelsHeight,SHEIGHT

IF WINDOWED EQ 1
invoke CreateWindowEx,0,ADDR szEdit,ADDR szTitle,WS_VISIBLE,0,0,SWIDTH,SHEIGHT,0,0,0,0
ELSE
;invoke ChangeDisplaySettings,ADDR dmScreenSettings,CDS_FULLSCREEN
invoke CreateWindowEx,0,ADDR szEdit,0,WS_POPUP OR WS_VISIBLE OR WS_MAXIMIZE,0,0,SWIDTH,SHEIGHT,0,0,0,0
ENDIF
mov hwnd,eax
invoke GetDC,eax
mov hdc,eax
invoke ChoosePixelFormat,hdc,ADDR pfd
invoke SetPixelFormat,hdc,eax,ADDR pfd
invoke wglCreateContext,hdc
invoke wglMakeCurrent,hdc,eax
IF WINDOWED EQ 0
invoke ShowCursor,0
ENDIF

IF DEBUG_SHADER EQ 1
invoke AllocConsole
invoke GetStdHandle,STD_OUTPUT_HANDLE
mov stdout,eax
ENDIF

invoke wglGetProcAddress,ADDR szCreateProgram
call eax
mov program,eax

invoke wglGetProcAddress,ADDR szCreateShader
mov ebx,GL_FRAGMENT_SHADER
push ebx
call eax
mov shader,eax

invoke wglGetProcAddress,ADDR szShaderSource
xor ebx,ebx
push ebx
push offset szShaderCode
inc ebx
push ebx
push shader
call eax

invoke wglGetProcAddress,ADDR szCompileShader
push shader
call eax

IF DEBUG_SHADER EQ 1
invoke wglGetProcAddress,ADDR szGetInfoLog
push offset szBuffer
xor ebx,ebx
push ebx
mov ebx,512
push ebx
push shader
call eax
invoke lstrlen,ADDR szBuffer
invoke WriteConsole,stdout,ADDR szBuffer,eax,ADDR dummy,NULL
ENDIF

invoke wglGetProcAddress,ADDR szAttachShader
push shader
push program
call eax

invoke wglGetProcAddress,ADDR szLinkProgram
push program
call eax

invoke wglGetProcAddress,ADDR szGetUniformLoc
mov glGetUniformLocation,eax
push offset szA
push program
call eax
mov unfD1,eax

push offset szB
push program
mov eax,glGetUniformLocation
call eax
mov unfD2,eax

push offset szC
push program
mov eax,glGetUniformLocation
call eax
mov unfD3,eax

invoke wglGetProcAddress,ADDR szUniform1f
mov glUniform1f,eax

; Get starting time and frequency
invoke QueryPerformanceCounter,ADDR perfCnt1
invoke QueryPerformanceFrequency,ADDR perfFreq

invoke wglGetProcAddress,ADDR szUseProgram
push program
call eax

invoke GetWindowRect,hwnd,ADDR rect

@@forever:
	fild dword ptr rect.right
	fstp dword ptr delta2
	push delta2
	push unfD2
	mov ebx,glUniform1f
	call ebx

	fild dword ptr rect.bottom
	fstp dword ptr delta3
	push delta3
	push unfD3
	mov ebx,glUniform1f
	call ebx

	invoke glBegin,GL_QUADS
	
	invoke glVertex2fv,ADDR quadCoords
	invoke glVertex2fv,ADDR quadCoords+8
	invoke glVertex2fv,ADDR quadCoords+16
	invoke glVertex2fv,ADDR quadCoords+24
	
	invoke glEnd
	
	; Update the movement delta
	invoke QueryPerformanceCounter,ADDR perfCnt2
	fild qword ptr perfCnt2.QuadPart
	fild qword ptr perfCnt1.QuadPart
	fsubp st(1),st(0)
	fild qword ptr perfFreq.QuadPart
	fdivp st(1),st(0)
	fimul word ptr deltaMul
	fld dword ptr delta1
	faddp st(1),st(0)
	fstp dword ptr delta1
	push perfCnt2.LowPart
	pop perfCnt1.LowPart
	push perfCnt2.HighPart
	pop perfCnt1.HighPart

	push delta1
	push unfD1
	mov ebx,glUniform1f
	call ebx

	invoke SwapBuffers,hdc
	
	IF WINDOWED EQ 1
	invoke GetMessage,ADDR msg,NULL,0,0
	.if eax > 0
		invoke TranslateMessage,ADDR msg
		invoke DispatchMessage,ADDR msg
	.endif
	ENDIF
	invoke GetAsyncKeyState,VK_ESCAPE
	test eax,eax
	jz @@forever


invoke wglGetProcAddress,ADDR szDeleteShader
push shader
call eax

invoke wglGetProcAddress,ADDR szDeleteProgram
push program
call eax

invoke ExitProcess,0

END WinMainCRTStartup

